import bpy
from bpy.props import *
from . import layer_scene_utils
# init

global glob_active_sceneLayer
global glob_main_sceneLayer


glob_active_sceneLayer = None
glob_main_sceneLayer = None

global glob_main_scene_name
glob_main_scene_name = '_Viewport'


	# get set properties of active_sceneLayer
def active_scenelayer_get(self):
	global glob_active_sceneLayer	
	return glob_active_sceneLayer

	
def active_scenelayer_set(self, value):
	print("setting active_scenelayer to %s" %(value))
	global glob_active_sceneLayer
	glob_active_sceneLayer  = value
	
	# get set properties of active_sceneLayer
def main_scenelayer_get(self):
	global glob_main_sceneLayer	
	if( glob_main_sceneLayer == None):
		return '_Viewport'
	return glob_main_sceneLayer

	
def main_scenelayer_set(self, value):
	print("setting glob_main_sceneLayer to %s" %(value))
	global glob_main_sceneLayer
	glob_main_sceneLayer  = value
	
	
def layersceneparent_get(self):
	return self['layersceneparent_val']
	
def layersceneparent_set(self, value):
	print("self/value")
	
	self['layersceneparent_val'] = value
	
def obj_scenelayer_get(self):
	# see if object is in a scenelayer
	scenelayer = None
	found_scenes = self.users_scene
	
	for scn in found_scenes:
		if( scn.scenelayer_data.is_scenelayer == True ):
			scenelayer = scn
	return scenelayer

def obj_scenelayer_set(self, value):
	
	None
	
def obj_scenelayer_get(self):
	
	None

def scenelayer_locked_update(self, context):
	print("Lock updated")
	is_locked = self.is_locked
	layer_scene_utils.Update_Main_Scene()
	#print("Scenelayer name: %s" %(self.name))
	
			# make _viewport active
	main_scene = layer_scene_utils.Get_Main_Scene()		
	bpy.context.screen.scene=bpy.data.scenes[main_scene.name]
		
	return None

	
class SceneLayer_Data(bpy.types.PropertyGroup):
	is_visible = bpy.props.BoolProperty( default= True, name='Show/Hide', update=scenelayer_locked_update )
	is_scenelayer = bpy.props.BoolProperty( default= False, name='Show/Hide' )
	is_optionsexanded = bpy.props.BoolProperty( default= False, name='Show/Hide' )
	is_locked = bpy.props.BoolProperty(default=False , name='Lock/Unlock', update=scenelayer_locked_update)
	
	name = bpy.props.StringProperty(default='defaultlayername', name="Layer name")
	main_scenelayer = property( main_scenelayer_get, main_scenelayer_set)
	parent = bpy.props.StringProperty(default='', name="Parent Layer")
	
# Register important components
def register():
	global glob_main_scene_name
	
	bpy.types.Scene.new_scenelayer_name = bpy.props.StringProperty(default='', name="Layer name")
	
	# dynamic properties
	bpy.types.Scene.active_scenelayer = property( active_scenelayer_get, active_scenelayer_set)
	bpy.types.Object.scenelayer = property(obj_scenelayer_get, obj_scenelayer_set)	
		# scene layer group
	#bpy.utils.register_class( SceneLayer_Data )	
	bpy.types.Scene.scenelayer_data = PointerProperty(type=SceneLayer_Data)
   
   
   
if __name__ == "__main__":
	register()

#init_module()

print("Imported Layer_scene_main.py")